﻿using MediatR;
using Microsoft.Extensions.DependencyInjection;

namespace Core.Events
{
    public static class Config
    {
        public static IServiceCollection AddEventHandler<TEvent, TEventResult, TEventHandler>(
            this IServiceCollection services
        )
            where TEvent : IEvent
            where TEventHandler : class, IEventHandler<TEvent>
        {
            return services.AddTransient<TEventHandler>()
                .AddTransient<INotificationHandler<TEvent>>(sp => sp.GetRequiredService<TEventHandler>())
                .AddTransient<IEventHandler<TEvent>>(sp => sp.GetRequiredService<TEventHandler>());
        }
    }
}
